#include <stdlib.h>
#include <stdio.h>
#include <windows.h>



int main(int argc, char *argv[])
{
    FILE *file;
    unsigned char data[32768+8];
    char name[MAX_PATH];
    char ext;
    int i,j,c1,c2,pp,size;
    bool mikrosha;

    if(argc<2)
    {
        printf("BIN2RK by Shiru (shiru@mail.ru) 10'10\n");
        printf("Usage: bin2rk.exe [format] filename.bin\n");
        printf("       [-r] Radio-86RK\n");
        printf("       -m   Mikrosha\n");
        printf("       -a   Apogey BK01\n");
        printf("       -p   Partner 01.01\n");
        return 0;
    }

    mikrosha=false;
    i=1;
    ext=' ';

    if(argv[1][0]=='-')
    {
        i=2;
        ext=argv[1][1];
        if(ext>='A'&&ext<='Z') ext+=32;
        if(ext!='r'&&ext!='m'&&ext!='a'&&ext!='p')
        {
            printf("Unknown format\n");
            return 1;
        }
        if(ext=='m') mikrosha=true;
    }

    file=fopen(argv[i],"rb");
    strcpy(name,argv[i]);
    
    if(!file)
    {
        printf("Can't open file\n");
        return 1;
    }
    
    fseek(file,0,SEEK_END);
    size=ftell(file);
    fseek(file,0,SEEK_SET);
    
    if(size>=32768)
    {
        printf("File too large\n");
        return 1;
    }
    
    fread(&data[mikrosha?4:5],size,1,file);
    fclose(file);
    
    pp=0;
    if(!mikrosha) data[pp++]=0xe6;
    data[pp++]=0;
    data[pp++]=0;
    data[pp++]=(size-1)/256;
    data[pp++]=(size-1)&255;
    
    c1=0;
    c2=0;

    if(!mikrosha)
    {
        for(i=0;i<size-1;i++) c1+=data[i+5];
        for(i=0;i<size;i++) c2+=data[i+5];
        c1+=(c1>>8);
    }
    else
    {
        for(i=0;i<size;i++)
        {
            if(i&1) c1^=data[i+4]; else c2^=data[i+4];
        }
    }

    pp+=size;
    if(!mikrosha) data[pp++]=0xe6;
    data[pp++]=c1;
    data[pp++]=c2;
    
    //printf("%2.2x %2.2x\n",c1,c2);
    
    name[strlen(name)-3]='r';
    name[strlen(name)-2]='k';
    name[strlen(name)-1]=ext;
    
    file=fopen(name,"wb");
    fwrite(data,pp,1,file);
    fclose(file);

    return 0;
}
